//debug("background started");
let prefs={};

var redirect = {
  
  getAddress: async function(info) {
debug('got Addresses');
    if (info.selectedMessages && info.selectedMessages.messages.length > 0) {
      this.msgs=info.selectedMessages.messages;
debug('num of messages='+this.msgs.length);

this.msgs.forEach( async mh => {
//debug('mh='+JSON.stringify(mh));
debug('got message id='+mh.id+' '+mh.subject+' ('+mh.author+')');
});

      //id=1 folder={"accountId":"account1","name":"Posteingang","path":"/INBOX","type":"inbox"}
      messenger.runtime.onMessage.addListener(this.handleMessage);
      let w=await messenger.windows.create({
        height: 300+this.msgs.length*18,
        width: 600,
        url: "/smr_addresses.html",
        type: "popup"
      });
/*
      let t=await messenger.tabs.create({
        active: true,
        url: "/smr_addresses.html"
      });
*/
//TODO: get real window for w.id
//TODO: window,resizeTo(width, height) oder window.resizeBy(xDelta, yDelta)  im implementation

    } else {
console.log('SMR: No message selected');
    }
    return;
  },

  handleMessage: function (request, sender, sendResponse) {
    if (request && request.action) switch (request.action) {
      case 'requestData':      // send info about selected messages to popup
        prefs=request.prefs;
debug('requestData, send messages, prefs now '+JSON.stringify(prefs));
        sendResponse(redirect.msgs);
        break;
    }
    return true;
  }

}

async function start() {
  prefs=await messenger.storage.local.get();
  if (!('debug' in prefs)) prefs.debug=false;
  let resent=messenger.i18n.getMessage('resent');
  messenger.menus.create({
    contexts : ["message_list"],
    id: "smr_redirect_mail",
    onclick : redirect.getAddress.bind(redirect),
    title: resent
  });

  messenger.smr.init(prefs);   //loads stylesheet etc.
}

start();

let debugcache='';
function debug(txt, force) {
	if (force || prefs) {
		if (force || prefs.debug) {
			if (debugcache) console.log(debugcache); debugcache='';
			console.log('SMR: '+txt);
		}
	} else {
		debugcache+='SMR: '+txt+'\n';
	}
}
